// spi.c
//
// Example program for bcm2835 library
// Shows how to interface with SPI to transfer a byte to and from an SPI device
//
// After installing bcm2835, you can build this
// with something like:
// gcc -o spi spi.c -l bcm2835
// sudo ./spi
//
// Or you can test it before installing with:
// gcc -o spi -I ../../src ../../src/bcm2835.c spi.c
// sudo ./spi
//
// Author: Mike McCauley
// Copyright (C) 2012 Mike McCauley
// $Id: RF22.h,v 1.21 2012/05/30 01:51:25 mikem Exp $
#include "entetes.h"

using namespace std;

const std::string Sregistre[] = {"CONFIG","EN_AA","EN_RXADDR","SETUP_AW","SETUP_RETR","RF_CH","RF_SETUP","STATUS","OBSERVE_TX","CD","RX_ADDR_P0","RX_ADDR_P1","RX_ADDR_P2","RX_ADDR_P3","RX_ADDR_P4","RX_ADDR_P5",
                                 "TX_ADDR","RX_PW_P0","RX_PW_P1","RX_PW_P2","RX_PW_P3","RX_PW_P4","RX_PW_P5","FIFO_STATUS"
                                };

uint8_t  init = 0;
bool flagWR=0;      //flag pour deffinir le mode: par defaut  0 = lecture 1=ecriture


#define pin  RPI_V2_GPIO_P1_11

void ecrituretxplayload(int *data,int len);
void lectureregistre(void);
void ecritureregistre(int registre ,int *data , bool multioctets);
int read1byteregistre(unsigned short int );
void read18byteregistre(unsigned short int );

int main(int argc, char **argv)
{
    int buffer[33];
    // If you call this, it will not actually access the GPIO
// Use for testing
//        bcm2835_set_debug(1);

    if (!bcm2835_init())
        return 1;

    bcm2835_spi_begin();
    bcm2835_spi_setBitOrder(BCM2835_SPI_BIT_ORDER_MSBFIRST);      // The default
    bcm2835_spi_setDataMode(BCM2835_SPI_MODE0);                   // The default
    bcm2835_spi_setClockDivider(BCM2835_SPI_CLOCK_DIVIDER_65536); // The default
    bcm2835_spi_chipSelect(BCM2835_SPI_CS0);                      // The default
    bcm2835_spi_setChipSelectPolarity(BCM2835_SPI_CS0, LOW);      // the default

    bcm2835_gpio_set_pud(pin, BCM2835_GPIO_PUD_OFF);
    bcm2835_gpio_fsel(pin, BCM2835_GPIO_FSEL_OUTP);



    ecrituretxplayload(buffer,32);                         //chargement du buffer d'emission

    buffer[0]=0x20;
    ecritureregistre(RX_PW_P0,buffer,0);                  //initialise la taille du buffer de reception  du pipe0 à 32bytes

    buffer[0]=0x20;
    ecritureregistre(RX_PW_P1,buffer,0);                  //initialise la taille du buffer de reception  du pipe1 à 32bytes


    buffer[0]=0x0a;
    ecritureregistre(CONFIG,buffer,0);                  //power on, ptx

    bcm2835_gpio_set(pin);                      //CE = 1
    while(read1byteregistre(STATUS)!=0x2E);     //on attend que le bit tx du registre status soit mis à 1 , indiquand la transmition terminée

   // lectureregistre();

	cout << "transmission OK "<< endl;  

    bcm2835_spi_end();
    bcm2835_close();
    return 0;
}

void lectureregistre(void)
{
    char	buf[7];
    uint32_t  	len;



    while (1)
    {
        string valeur = "";
        unsigned short int registre2;
        char lectureecriture;
        int valeurregistre;
        int  data[7];

        /*Partie saisie et vérifications des valeurs des registre etdes données*/
bouclechar:
        cout << "l pour lecture ,e pour écriture"<< endl<<">";      //choix du mode ecriture ou lecture
        cin>>lectureecriture;                                       //et test si les letrres e E l L on ete entrées si non message d erreure et reboucle
        if(!testsichar(lectureecriture))
        {
            goto bouclechar;
        }

bouclenum:
        cout << "entrer le numerot du registre "<< endl;            //choix du registre à lire ou ecrire
        printf("entrer un numerot entre 0 et 12 \n");               //test si l'entrée est bien un chiffre
        printf(">");
        cin>>registre2;
        if(!testsinumerique())
        {
            goto bouclenum;
        }

boucledata:
        if (lectureecriture=='e' || lectureecriture =='E')            //le mode est ecriture donc on demande la valeur de registre à écrire
        {

            if(registre2==11 ||registre2==10 || registre2==16)
            {
                for(unsigned int i=0;i<5;i++)
                {
                    cout<<"entrez valeur de l'octet"<<i<<endl<<">";
                    cin>>data[i];
                }
            }
            else
            {
                cout<<"entrez la valeur à ecrire dans le registre"<<endl;
                cin>> data[0];
                if(!testsinumerique())
                {
                    goto boucledata;
                }
            }
        }

        /*Partie traitement des registres en lecture ou ecriture
        *le traitement est différent en fonction des registres à 1 octet ou  à 8octets*/
        if(registre2<9)
        {
            if(flagWR==0)
            {
                read1byteregistre(registre2);
            }
            if(flagWR==1)
            {
                ecritureregistre(registre2,data,0);
            }

        }
        else if(registre2<12&&registre2>9)
        {
            if (flagWR==0)
            {
                read18byteregistre(registre2);
            }
             if(flagWR==1)
            {
                ecritureregistre(registre2,data,1);
            }
        }

        else if(registre2<16)
        {
            if (flagWR==0)
            {
                read1byteregistre(registre2);
            }
            if(flagWR==1)
            {
                ecritureregistre(registre2,data,0);
            }
        }

        else if(registre2<17)
        {
            if(flagWR==0)
            {
                read18byteregistre(registre2);
            }
             if(flagWR==1)
            {
                ecritureregistre(registre2,data,1);
            }
        }
        else if(registre2<24)
        {
            if (flagWR==0)
            {
                read1byteregistre(registre2);
            }
            if(flagWR==1)
            {
                ecritureregistre(registre2,data,0);
            }
        }
        else if(registre2==26);
        else
        {
            len=2;
            for (uint8_t i=0; i<24; i++)
            {
                buf[0]=i;
                buf[1]=0x00;
                bcm2835_spi_transfern(buf,len);
                cout << "read from spi register "<<Sregistre[i]<<": 0x";
                printf("%02X\n", buf[1]);
            }
        }
    }

}

void ecrituretxplayload(int *data,int len)
{
  char	buf[33];
   int count;

    for( count=0;count<len;count++)
    {
        buf[0]=0xa0  ;               //opcode pour écrire dans txplayload
        buf[(count+1)]= count;

    }


    bcm2835_spi_transfern(buf,len);
}

void ecritureregistre(int registre ,int *data ,bool multioctets)
{

    char	buf[7];
    uint32_t  	len;



    buf[0]=(registre|0x020) ;
    buf[1]=data[0];
    buf[2]=data[1];
    buf[3]=data[2];
    buf[4]=data[3];
    buf[5]=data[4];

    if(multioctets==0)len=2;
    if(multioctets==1)len=6;
    bcm2835_spi_transfern(buf,len);
    printf("le registre %02X à ete ecrit\n", registre);
}


int read1byteregistre(unsigned short int registre )
{
    char	buf[7];
    uint32_t  	len;

    buf[0]=(registre);
    buf[1]=0x00;
    len=2;
    bcm2835_spi_transfern(buf,len);
    cout << "read from spi register "<<Sregistre[registre]<<": 0x";
    printf("%02X\n", buf[1]);
    return buf[1];
}

void read18byteregistre(unsigned short int registre )
{
    char	buf[7];
    uint32_t  	len;


    buf[0]=(registre);
    buf[1]=0x00;
    buf[2]=0x00;
    buf[3]=0x00;
    buf[4]=0x00;
    buf[5]=0x00;
    len=6;
    bcm2835_spi_transfern(buf,len);
    cout << "read from spi register "<<Sregistre[registre]<<": 0x";
    printf("%02X", buf[5]);
    printf("%02X", buf[4]);
    printf("%02X", buf[3]);
    printf("%02X", buf[2]);
    printf("%02X\n", buf[1]);

}
